<template>
    <q-page class="bg-base">
        <DocumentWrapper ref='wrap'>
            <q-splitter v-model="splitterModel" :horizontal="$q.platform.is.mobile">
                <template #before>

                    <div class="q-pa-lg">
                        <div ref="master-parent" class="full-width relative-position">
                            <q-resize-observer @resize="AdjustSizes"/>
                            <div v-if='image!==""' class="full-width relative-position smooth"
                                 :style="`height: ${floorplanH}px`">
                                <img :src="image" v-if="image !== ''" alt="Please upload a floorplan"
                                     class="fit fp-img"/>
                                <FloorPlanCanvas v-if="image !== ''"
                                                 :painter-config="PainterConfig"
                                                 :colored-floor-plan="floorPlan"
                                                 class="top-canvas fp-text"/>
                                <FloorPlanTextRender v-if="image !== ''" class="absolute"/>
                            </div>
                        </div>
                        <q-btn @click="imageDialog = true" color="primary">
                            Choose floorPlan
                        </q-btn>
                    </div>

                </template>
                <template #after>
                    <Form ref='form'
                          class="col-lg-2 col-12 q-pa-lg"
                          :fields="fields"
                          title="Create FloorPlan"
                          @unknown="SubmitError"
                          @auth="SubmitError"
                          :on-submit="Submit"
                          @success="SubmitSuccess"
                          v-model="models">
                    </Form>

                </template>
            </q-splitter>
            <q-dialog v-model="imageDialog" persistent>
                <div class="bg-base q-pa-lg">
                    <div class="column q-gutter-y-sm">

                        <div class="text-h5 text-weight-light ">
                            Please choose a floorplan
                        </div>
                        <Base64Uploader
                            color="teal"
                            flat
                            bordered
                            :on-upload="OnUpload"
                            label="Upload a floorplan"
                            style="max-width: 300px"
                            @success="imageDialog = false"
                        />
                        <q-btn @click="imageDialog = false" color="secondary">
                            Back
                        </q-btn>
                    </div>
                </div>

            </q-dialog>

        </DocumentWrapper>
    </q-page>
</template>

<style lang='scss' scoped>
.fp-img {
    position: absolute;
    z-index: 1;
}

.fp-text {
    position: absolute;
    top: 0;
    z-index: 3;
}

.top-canvas {
    position: absolute;
    top: 0;
    z-index: 2;
}
</style>

<script lang='ts'>
import {Component, Vue, Watch} from 'vue-property-decorator';
import Form from "components/Form.vue";
import {FloorPlanFullResponse} from "src/classLibrary/APIModels/core/floorPlanFullResponse";
import ImageUploader from "components/Core/ImageUploader.vue";
import FloorPlanCanvas from "components/FloorPlan/FloorPlanCanvas.vue";
import FloorPlanTextRender from "components/FloorPlan/FloorPlanTextRender.vue";
import {PainterConfig} from "src/classLibrary/Geometry/Painter";
import {ColoredFloorPlanData} from "src/classLibrary/Geometry/Colored";
import {InputZone} from "src/classLibrary/Geometry/ZoneMapper";
import {InputExit} from "src/classLibrary/Geometry/ExitMapper";
import {FloorPlanMapper} from "src/classLibrary/Geometry/FloorPlanMapper";
import {ColoredMapper} from "src/classLibrary/Geometry/ColoredMapper";
import {Err, Result} from "@hqoss/monads";
import {ApiError} from "src/classLibrary/Core/Api";
import {LoadImageAsBase64} from "src/classLibrary/Utility";
import {FloorResponse} from "src/classLibrary/APIModels/core/floorResponse";
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import {BasicFormModel, FormInput} from "src/classLibrary/FormTypes";
import Base64Uploader from "src/mixins/Base64Uploader";


//@ts-ignore
@Component({
    components: {
        Base64Uploader,
        DocumentWrapper, FloorPlanTextRender, FloorPlanCanvas, ImageUploader, Form
    }
})
export default class CreateFloorPlan extends Vue {

    image = '';
    imageDialog = false;
    splitterModel = 80;
    routeParams = {
        floorId: ''
    }

    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    SubmitError(e: ApiError) {
        this.Wrap.SubmitError(e);
    }


    floorplanW: number = 1;
    floorplanH: number = 1;
    floorPlan: ColoredFloorPlanData = {quads: [], lines: [], height: 0, width: 0}

    OnUpload(i: string[]) {
        this.image = i[0];
    }


    @Watch('models', {deep: true, immediate: false})
    OnModelsUpdate() {
        this.ConvertToColored();
        this.AdjustSizes();
    }

    models: BasicFormModel = {
        valid: false,
        models: {
            name: '',
            width: 10,
            height: 5,
            exits: '{}',
            zones: '{}'
        }
    }


    get PainterConfig(): PainterConfig {
        return {
            width: this.floorplanW,
            height: this.floorplanH,
            exitAlpha: 1,
            exitWidth: 5,
            drawExit: true,
            drawZone: true,
            showDanger: true,
            dangerIntensity: 10,
            zoneAlpha: 0.2
        }
    }


    get Form(): Form {
        return this.$refs.form as any;
    }

    async init() {
        const token = await this.$auth.CoreToken;
        const floor = await this.$coreApi.Get<FloorResponse>(`Floor/${this.routeParams.floorId}`, null, token)
        const p = this;
        if (floor.isErr()) {
            this.Store.StoreValue.loading = false;
            return this.Wrap.SubmitError(floor.unwrapErr())
        }
        const f = floor.unwrap();
        if (f.latestFloorPlan == null) {
            return
        }
        const fp = await this.$coreApi.Get<FloorPlanFullResponse>(
            `FloorPlan/${this.routeParams.floorId}/${f.latestFloorPlan.id}`, null, token);
        await fp.match<Promise<void>>({
            ok: async (o) => {
                const [z, e, w, h] = FloorPlanMapper.From(o)
                p.floorPlan = new ColoredMapper('original').To(w, h, z, e).Data

                p.models.models.name = o.info.name;
                p.models.models.width = w;
                p.models.models.height = h;
                p.models.models.exits = JSON.stringify(e.AsObject(), null, 2);
                p.models.models.zones = JSON.stringify(z.AsObject(), null, 2);
                try {
                    p.image = await LoadImageAsBase64(o.info.image);
                } catch {

                }
                p.AdjustSizes();
            },
            err: async (e) => {
                p.Wrap.SubmitError(e)
            }

        })

    }

    AdjustSizes() {
        const p = (this.$refs['master-parent'] as Element);
        const w = p.getBoundingClientRect().width;
        const h = w / this.models.models.width.ToFloat() * this.models.models.height.ToFloat();
        Vue.set(this, 'floorplanW', w);
        Vue.set(this, 'floorplanH', h);

    }


    GenerateRequest() {
        const z = JSON.parse(this.models.models.zones) as { [s: string]: InputZone };
        const e = JSON.parse(this.models.models.exits) as { [s: string]: InputExit };
        return FloorPlanMapper.To(z, e, this.models.models.height.ToFloat(),
            this.models.models.width.ToFloat(), this.image, this.models.models.name, '{}');
    }

    ConvertToColored() {
        const request = this.GenerateRequest();
        const [zones, exits, w, h] = FloorPlanMapper.FromRequest(request);
        this.floorPlan = new ColoredMapper('original').To(w, h, zones, exits).Data;
    }

    Save(image: string) {
        this.image = image;
    }

    fields: FormInput[] = [
        {
            rules: [
                (v: string) => !!v || 'Please enter name for this floorplan version',
                (v: string) => (v.length < 128 && v.length > 1) || 'Floorplan version name has to be between 2 to 128 characters',
            ],
            label: 'Floorplan Version',
            tooltip: "Give your floorplan a version name",
            icon: "icofont-paperclip",
            key: 'name',
            max: 128,
            baseType: 'basic',
            type: 'text',
        },
        {
            rules: [
                (v: number) => !!v || 'Please enter floorplan width',
                (v: number) => (v > 0) || 'Floorplan width has to be positive',
            ],
            label: 'Floorplan width',
            tooltip: "Virtual width of your floorplan",
            icon: "panorama_horizontal",
            key: 'width',
            baseType: 'number',
        },
        {
            rules: [
                (v: number) => !!v || 'Please enter floorplan height',
                (v: number) => (v > 0) || 'Floorplan height has to be positive',
            ],
            label: 'Floorplan height',
            tooltip: "Virtual height of your floorplan",
            icon: "panorama_vertical",
            key: 'height',
            baseType: 'number',
        },
        {
            rules: [
                (v: string) => !!v || 'Invalid exit',
                ((v: string) => {
                    try {
                        JSON.parse(v);
                        return true;
                    } catch {
                        return false;
                    }
                }) || 'Invalid exit',
            ],
            label: 'Exits',
            tooltip: "FloorPlan exits",
            icon: "exit_to_app",
            baseType: 'basic',
            type: 'text',
            key: 'exits',
            autogrow: true,
        },
        {
            rules: [
                (((v: string) => !!v || 'Please ZONE') as any),
                ((((v: string) => {
                    try {
                        JSON.parse(v);
                        return true;
                    } catch {
                        return false;
                    }
                }) || 'Invalid zone') as any),
            ],
            label: 'Zones',
            tooltip: "Floorplan Zones",
            icon: "layers",
            key: 'zones',
            baseType: 'basic',
            type: 'text',
            autogrow: true,
        },
    ]


    async Submit(_: any): Promise<Result<FloorPlanFullResponse, ApiError>> {
        this.Store.StoreValue.loading = true;
        if (this.image == '') {
            this.Store.StoreValue.loading = false;
            return Err(ApiError.String({code: 400, error: 'Please choose a floorplan image'}));
        }
        const t = await this.$auth.CoreToken;
        const pid = this.PersistentStore.StoreValue.project;
        const r = this.GenerateRequest();
        const result = await this.$coreApi.Post<FloorPlanFullResponse>(`FloorPlan/${pid}/${this.routeParams.floorId}`, r, t);
        this.Store.StoreValue.loading = false;
        return result;
    }

    async SubmitSuccess(f: FloorPlanFullResponse) {
        this.$q.notify({color: 'positive', message: `Successfully created floorplan ${f.info.name}`, icon: 'check'});
        await this.$router.push(`/floor/${this.routeParams.floorId}/floorplan`);
    }

}
</script>
